Jonathan Nieder | 11d6214 | 2013-11-25 13:03:52 -0800 | [diff] [blame] | 1 | # This shell scriplet is meant to be included by other shell scripts |
| 2 | # to set up some variables pointing at the normal git directories and |
| 3 | # a few helper shell functions. |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 4 | |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 5 | # Having this variable in your environment would break scripts because |
Junio C Hamano | e598c51 | 2007-09-15 16:32:23 -0700 | [diff] [blame] | 6 | # you would cause "cd" to be taken to unexpected places. If you |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 7 | # like CDPATH, define it for your interactive shell sessions without |
| 8 | # exporting it. |
Junio C Hamano | 785063e | 2012-08-08 12:08:17 -0700 | [diff] [blame] | 9 | # But we protect ourselves from such a user mistake nevertheless. |
Junio C Hamano | 365527a | 2005-09-12 19:47:07 -0700 | [diff] [blame] | 10 | unset CDPATH |
| 11 | |
Junio C Hamano | 393050c | 2012-12-07 14:31:52 -0800 | [diff] [blame] | 12 | # Similarly for IFS, but some shells (e.g. FreeBSD 7.2) are buggy and |
| 13 | # do not equate an unset IFS with IFS with the default, so here is |
| 14 | # an explicit SP HT LF. |
| 15 | IFS=' |
| 16 | ' |
Junio C Hamano | 785063e | 2012-08-08 12:08:17 -0700 | [diff] [blame] | 17 | |
Junio C Hamano | 61dbb3c | 2009-06-08 09:41:49 -0700 | [diff] [blame] | 18 | git_broken_path_fix () { |
| 19 | case ":$PATH:" in |
| 20 | *:$1:*) : ok ;; |
| 21 | *) |
| 22 | PATH=$( |
| 23 | SANE_TOOL_PATH="$1" |
| 24 | IFS=: path= sep= |
| 25 | set x $PATH |
| 26 | shift |
| 27 | for elem |
| 28 | do |
| 29 | case "$SANE_TOOL_PATH:$elem" in |
| 30 | (?*:/bin | ?*:/usr/bin) |
| 31 | path="$path$sep$SANE_TOOL_PATH" |
| 32 | sep=: |
| 33 | SANE_TOOL_PATH= |
| 34 | esac |
| 35 | path="$path$sep$elem" |
| 36 | sep=: |
| 37 | done |
| 38 | echo "$path" |
| 39 | ) |
| 40 | ;; |
| 41 | esac |
| 42 | } |
| 43 | |
| 44 | # @@BROKEN_PATH_FIX@@ |
Junio C Hamano | 0e0aea5 | 2009-06-05 18:36:15 -0500 | [diff] [blame] | 45 | |
Fredrik Gustafsson | adb231c | 2011-06-09 09:47:02 +0200 | [diff] [blame] | 46 | die () { |
| 47 | die_with_status 1 "$@" |
| 48 | } |
| 49 | |
| 50 | die_with_status () { |
| 51 | status=$1 |
| 52 | shift |
Matthieu Moy | 89b0230 | 2013-08-07 11:26:05 +0200 | [diff] [blame] | 53 | printf >&2 '%s\n' "$*" |
Fredrik Gustafsson | adb231c | 2011-06-09 09:47:02 +0200 | [diff] [blame] | 54 | exit "$status" |
Linus Torvalds | b33e966 | 2005-07-08 10:57:21 -0700 | [diff] [blame] | 55 | } |
| 56 | |
Stephen Boyd | e064c17 | 2009-06-16 15:32:59 -0700 | [diff] [blame] | 57 | GIT_QUIET= |
| 58 | |
| 59 | say () { |
| 60 | if test -z "$GIT_QUIET" |
| 61 | then |
| 62 | printf '%s\n' "$*" |
| 63 | fi |
| 64 | } |
| 65 | |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 66 | if test -n "$OPTIONS_SPEC"; then |
| 67 | usage() { |
Junio C Hamano | 5d29275 | 2007-12-20 12:58:06 -0800 | [diff] [blame] | 68 | "$0" -h |
| 69 | exit 1 |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 70 | } |
| 71 | |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 72 | parseopt_extra= |
| 73 | [ -n "$OPTIONS_KEEPDASHDASH" ] && |
| 74 | parseopt_extra="--keep-dashdash" |
Nicolas Vigier | 51ba8ce | 2014-02-01 02:17:59 +0000 | [diff] [blame] | 75 | [ -n "$OPTIONS_STUCKLONG" ] && |
| 76 | parseopt_extra="$parseopt_extra --stuck-long" |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 77 | |
| 78 | eval "$( |
Junio C Hamano | cbea86f | 2007-11-07 23:04:38 -0800 | [diff] [blame] | 79 | echo "$OPTIONS_SPEC" | |
Pierre Habouzit | e817e3e | 2007-11-08 10:32:11 +0100 | [diff] [blame] | 80 | git rev-parse --parseopt $parseopt_extra -- "$@" || |
| 81 | echo exit $? |
| 82 | )" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 83 | else |
Stephan Beyer | 1b1dd23 | 2008-07-13 15:36:15 +0200 | [diff] [blame] | 84 | dashless=$(basename "$0" | sed -e 's/-/ /') |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 85 | usage() { |
David Aguilar | 0b54366 | 2013-02-23 16:50:09 -0800 | [diff] [blame] | 86 | die "usage: $dashless $USAGE" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 87 | } |
| 88 | |
| 89 | if [ -z "$LONG_USAGE" ] |
| 90 | then |
David Aguilar | 0b54366 | 2013-02-23 16:50:09 -0800 | [diff] [blame] | 91 | LONG_USAGE="usage: $dashless $USAGE" |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 92 | else |
David Aguilar | 0b54366 | 2013-02-23 16:50:09 -0800 | [diff] [blame] | 93 | LONG_USAGE="usage: $dashless $USAGE |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 94 | |
| 95 | $LONG_USAGE" |
| 96 | fi |
| 97 | |
| 98 | case "$1" in |
Clemens Buchacher | 87182b1 | 2011-10-03 20:21:36 +0200 | [diff] [blame] | 99 | -h) |
Pierre Habouzit | bac199b | 2007-11-04 11:30:54 +0100 | [diff] [blame] | 100 | echo "$LONG_USAGE" |
| 101 | exit |
| 102 | esac |
| 103 | fi |
Fredrik Kuivinen | d025524 | 2005-12-11 10:55:49 +0100 | [diff] [blame] | 104 | |
Junio C Hamano | c3e2d18 | 2013-06-19 10:54:00 -0700 | [diff] [blame] | 105 | # Set the name of the end-user facing command in the reflog when the |
| 106 | # script may update refs. When GIT_REFLOG_ACTION is already set, this |
| 107 | # will not overwrite it, so that a scripted Porcelain (e.g. "git |
| 108 | # rebase") can set it to its own name (e.g. "rebase") and then call |
| 109 | # another scripted Porcelain (e.g. "git am") and a call to this |
| 110 | # function in the latter will keep the name of the end-user facing |
| 111 | # program (e.g. "rebase") in GIT_REFLOG_ACTION, ensuring whatever it |
| 112 | # does will be record as actions done as part of the end-user facing |
| 113 | # operation (e.g. "rebase"). |
| 114 | # |
| 115 | # NOTE NOTE NOTE: consequently, after assigning a specific message to |
| 116 | # GIT_REFLOG_ACTION when calling a "git" command to record a custom |
| 117 | # reflog message, do not leave that custom value in GIT_REFLOG_ACTION, |
| 118 | # after you are done. Other callers of "git" commands that rely on |
| 119 | # writing the default "program name" in reflog expect the variable to |
| 120 | # contain the value set by this function. |
| 121 | # |
| 122 | # To use a custom reflog message, do either one of these three: |
| 123 | # |
| 124 | # (a) use a single-shot export form: |
| 125 | # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" \ |
| 126 | # git command-that-updates-a-ref |
| 127 | # |
| 128 | # (b) save the original away and restore: |
| 129 | # SAVED_ACTION=$GIT_REFLOG_ACTION |
| 130 | # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" |
| 131 | # git command-that-updates-a-ref |
| 132 | # GIT_REFLOG_ACITON=$SAVED_ACTION |
| 133 | # |
| 134 | # (c) assign the variable in a subshell: |
| 135 | # ( |
| 136 | # GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: preparing frotz" |
| 137 | # git command-that-updates-a-ref |
| 138 | # ) |
Shawn O. Pearce | f947413 | 2006-12-28 02:34:48 -0500 | [diff] [blame] | 139 | set_reflog_action() { |
| 140 | if [ -z "${GIT_REFLOG_ACTION:+set}" ] |
| 141 | then |
| 142 | GIT_REFLOG_ACTION="$*" |
| 143 | export GIT_REFLOG_ACTION |
| 144 | fi |
| 145 | } |
| 146 | |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 147 | git_editor() { |
Jonathan Nieder | b4479f0 | 2009-10-30 20:42:34 -0500 | [diff] [blame] | 148 | if test -z "${GIT_EDITOR:+set}" |
| 149 | then |
| 150 | GIT_EDITOR="$(git var GIT_EDITOR)" || return $? |
| 151 | fi |
| 152 | |
| 153 | eval "$GIT_EDITOR" '"$@"' |
Adam Roben | ef0c2ab | 2007-07-19 22:09:35 -0700 | [diff] [blame] | 154 | } |
| 155 | |
Jonathan Nieder | f6dff11 | 2010-02-14 23:04:13 -0600 | [diff] [blame] | 156 | git_pager() { |
| 157 | if test -t 1 |
| 158 | then |
| 159 | GIT_PAGER=$(git var GIT_PAGER) |
| 160 | else |
| 161 | GIT_PAGER=cat |
| 162 | fi |
Matthieu Moy | b327583 | 2014-04-30 09:35:25 +0200 | [diff] [blame] | 163 | : ${LESS=-FRX} |
Jonathan Nieder | e54c1f2 | 2014-01-06 18:14:05 -0800 | [diff] [blame] | 164 | : ${LV=-c} |
| 165 | export LESS LV |
Jonathan Nieder | f6dff11 | 2010-02-14 23:04:13 -0600 | [diff] [blame] | 166 | |
| 167 | eval "$GIT_PAGER" '"$@"' |
| 168 | } |
| 169 | |
Junio C Hamano | e1622bf | 2009-11-23 15:56:32 -0800 | [diff] [blame] | 170 | sane_grep () { |
| 171 | GREP_OPTIONS= LC_ALL=C grep "$@" |
| 172 | } |
| 173 | |
| 174 | sane_egrep () { |
| 175 | GREP_OPTIONS= LC_ALL=C egrep "$@" |
| 176 | } |
| 177 | |
Junio C Hamano | 4b441f4 | 2007-01-07 02:17:52 -0800 | [diff] [blame] | 178 | is_bare_repository () { |
Junio C Hamano | 5be6007 | 2007-07-02 22:52:14 -0700 | [diff] [blame] | 179 | git rev-parse --is-bare-repository |
Junio C Hamano | 4b441f4 | 2007-01-07 02:17:52 -0800 | [diff] [blame] | 180 | } |
| 181 | |
Junio C Hamano | 9fde940 | 2007-01-12 12:44:08 -0800 | [diff] [blame] | 182 | cd_to_toplevel () { |
Steven Drake | 91dc602 | 2010-01-12 11:34:34 +1300 | [diff] [blame] | 183 | cdup=$(git rev-parse --show-toplevel) && |
| 184 | cd "$cdup" || { |
| 185 | echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree" |
| 186 | exit 1 |
| 187 | } |
Junio C Hamano | 9fde940 | 2007-01-12 12:44:08 -0800 | [diff] [blame] | 188 | } |
| 189 | |
Junio C Hamano | e2eb527 | 2011-05-04 19:11:18 -0700 | [diff] [blame] | 190 | require_work_tree_exists () { |
| 191 | if test "z$(git rev-parse --is-bare-repository)" != zfalse |
| 192 | then |
| 193 | die "fatal: $0 cannot be used without a working tree." |
| 194 | fi |
| 195 | } |
| 196 | |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 197 | require_work_tree () { |
Gabriel Filion | ab62677 | 2010-02-16 23:18:50 -0500 | [diff] [blame] | 198 | test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true || |
Shawn O. Pearce | 7eff28a | 2006-12-30 23:32:38 -0500 | [diff] [blame] | 199 | die "fatal: $0 cannot be used without a working tree." |
| 200 | } |
| 201 | |
Ramkumar Ramachandra | 92c62a3 | 2010-10-19 20:09:28 +0530 | [diff] [blame] | 202 | require_clean_work_tree () { |
| 203 | git rev-parse --verify HEAD >/dev/null || exit 1 |
| 204 | git update-index -q --ignore-submodules --refresh |
| 205 | err=0 |
| 206 | |
| 207 | if ! git diff-files --quiet --ignore-submodules |
| 208 | then |
| 209 | echo >&2 "Cannot $1: You have unstaged changes." |
| 210 | err=1 |
| 211 | fi |
| 212 | |
| 213 | if ! git diff-index --cached --quiet --ignore-submodules HEAD -- |
| 214 | then |
| 215 | if [ $err = 0 ] |
| 216 | then |
| 217 | echo >&2 "Cannot $1: Your index contains uncommitted changes." |
| 218 | else |
| 219 | echo >&2 "Additionally, your index contains uncommitted changes." |
| 220 | fi |
| 221 | err=1 |
| 222 | fi |
| 223 | |
| 224 | if [ $err = 1 ] |
| 225 | then |
| 226 | test -n "$2" && echo >&2 "$2" |
| 227 | exit 1 |
| 228 | fi |
| 229 | } |
| 230 | |
Jeff King | ce80ca5 | 2012-10-18 03:25:22 -0400 | [diff] [blame] | 231 | # Generate a sed script to parse identities from a commit. |
| 232 | # |
| 233 | # Reads the commit from stdin, which should be in raw format (e.g., from |
| 234 | # cat-file or "--pretty=raw"). |
| 235 | # |
| 236 | # The first argument specifies the ident line to parse (e.g., "author"), and |
| 237 | # the second specifies the environment variable to put it in (e.g., "AUTHOR" |
| 238 | # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and |
| 239 | # committer. |
| 240 | pick_ident_script () { |
| 241 | while test $# -gt 0 |
| 242 | do |
| 243 | lid=$1; shift |
| 244 | uid=$1; shift |
| 245 | printf '%s' " |
| 246 | /^$lid /{ |
| 247 | s/'/'\\\\''/g |
| 248 | h |
| 249 | s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'" |
| 250 | s/.*/GIT_${uid}_NAME='&'/p |
| 251 | |
| 252 | g |
| 253 | s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'" |
| 254 | s/.*/GIT_${uid}_EMAIL='&'/p |
| 255 | |
| 256 | g |
| 257 | s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'" |
| 258 | s/.*/GIT_${uid}_DATE='&'/p |
| 259 | } |
| 260 | " |
| 261 | done |
| 262 | echo '/^$/q' |
| 263 | } |
| 264 | |
| 265 | # Create a pick-script as above and feed it to sed. Stdout is suitable for |
| 266 | # feeding to eval. |
| 267 | parse_ident_from_commit () { |
| 268 | LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")" |
| 269 | } |
| 270 | |
| 271 | # Parse the author from a commit given as an argument. Stdout is suitable for |
| 272 | # feeding to eval to set the usual GIT_* ident variables. |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 273 | get_author_ident_from_commit () { |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 274 | encoding=$(git config i18n.commitencoding || echo UTF-8) |
Junio C Hamano | 077b725 | 2008-02-13 13:13:21 -0800 | [diff] [blame] | 275 | git show -s --pretty=raw --encoding="$encoding" "$1" -- | |
Jeff King | ce80ca5 | 2012-10-18 03:25:22 -0400 | [diff] [blame] | 276 | parse_ident_from_commit author AUTHOR |
Johannes Schindelin | 0cae234 | 2007-06-25 01:04:11 +0100 | [diff] [blame] | 277 | } |
| 278 | |
Giuseppe Bilotta | 7d750f0 | 2010-02-25 00:34:16 +0100 | [diff] [blame] | 279 | # Clear repo-local GIT_* environment variables. Useful when switching to |
| 280 | # another repository (e.g. when entering a submodule). See also the env |
| 281 | # list in git_connect() |
| 282 | clear_local_git_env() { |
| 283 | unset $(git rev-parse --local-env-vars) |
| 284 | } |
| 285 | |
Kevin Bracey | 4549162 | 2013-03-13 03:12:21 +0200 | [diff] [blame] | 286 | # Generate a virtual base file for a two-file merge. Uses git apply to |
| 287 | # remove lines from $1 that are not in $2, leaving only common lines. |
| 288 | create_virtual_base() { |
| 289 | sz0=$(wc -c <"$1") |
| 290 | @@DIFF@@ -u -La/"$1" -Lb/"$1" "$1" "$2" | git apply --no-add |
| 291 | sz1=$(wc -c <"$1") |
| 292 | |
| 293 | # If we do not have enough common material, it is not |
| 294 | # worth trying two-file merge using common subsections. |
| 295 | expr $sz0 \< $sz1 \* 2 >/dev/null || : >"$1" |
| 296 | } |
| 297 | |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 298 | |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 299 | # Platform specific tweaks to work around some commands |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 300 | case $(uname -s) in |
| 301 | *MINGW*) |
| 302 | # Windows has its own (incompatible) sort and find |
| 303 | sort () { |
| 304 | /usr/bin/sort "$@" |
| 305 | } |
| 306 | find () { |
| 307 | /usr/bin/find "$@" |
| 308 | } |
Ramsay Jones | be39048 | 2012-04-17 19:48:39 +0100 | [diff] [blame] | 309 | # git sees Windows-style pwd |
| 310 | pwd () { |
| 311 | builtin pwd -W |
| 312 | } |
Pat Thoyts | 5e9677c | 2010-09-30 14:24:07 +0100 | [diff] [blame] | 313 | is_absolute_path () { |
| 314 | case "$1" in |
| 315 | [/\\]* | [A-Za-z]:*) |
| 316 | return 0 ;; |
| 317 | esac |
| 318 | return 1 |
| 319 | } |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 320 | ;; |
Pat Thoyts | 5e9677c | 2010-09-30 14:24:07 +0100 | [diff] [blame] | 321 | *) |
| 322 | is_absolute_path () { |
| 323 | case "$1" in |
| 324 | /*) |
| 325 | return 0 ;; |
| 326 | esac |
| 327 | return 1 |
| 328 | } |
Johannes Sixt | 87bddba | 2007-11-30 22:06:30 +0100 | [diff] [blame] | 329 | esac |
Junio C Hamano | 10587ce | 2012-05-16 10:36:01 -0700 | [diff] [blame] | 330 | |
| 331 | # Make sure we are in a valid repository of a vintage we understand, |
| 332 | # if we require to be in a git repository. |
| 333 | if test -z "$NONGIT_OK" |
| 334 | then |
| 335 | GIT_DIR=$(git rev-parse --git-dir) || exit |
| 336 | if [ -z "$SUBDIRECTORY_OK" ] |
| 337 | then |
| 338 | test -z "$(git rev-parse --show-cdup)" || { |
| 339 | exit=$? |
| 340 | echo >&2 "You need to run this command from the toplevel of the working tree." |
| 341 | exit $exit |
| 342 | } |
| 343 | fi |
| 344 | test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || { |
| 345 | echo >&2 "Unable to determine absolute path of git directory" |
| 346 | exit 1 |
| 347 | } |
| 348 | : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"} |
| 349 | fi |
Ramkumar Ramachandra | bac1ddd | 2013-06-14 18:47:51 +0530 | [diff] [blame] | 350 | |
| 351 | peel_committish () { |
| 352 | case "$1" in |
| 353 | :/*) |
| 354 | peeltmp=$(git rev-parse --verify "$1") && |
| 355 | git rev-parse --verify "${peeltmp}^0" |
| 356 | ;; |
| 357 | *) |
| 358 | git rev-parse --verify "${1}^0" |
| 359 | ;; |
| 360 | esac |
| 361 | } |